/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#include "Ai8051U.h"
#include "usb.h"
#include "usb_req_class.h"

BYTE bHidIdle;
BYTE bKeyCode = 0;
BOOL fKeyOK;

WORD Key1_cnt;
WORD Key2_cnt;
BOOL Key1_Flag;
BOOL Key2_Flag;

//sbit KEY1 = P3^2;
SBIT(KEY1,0xb0/*P3*/,2);
//sbit KEY2 = P3^3;
SBIT(KEY2,0xb0/*P3*/,3);

// sbit LED_NUM        = P2^7;
// sbit LED_CAPS       = P2^6;
// sbit LED_SCROLL     = P2^5;

SBIT(LED_NUM,0xa0/*P2*/,7);
SBIT(LED_CAPS,0xa0/*P2*/,6);
SBIT(LED_SCROLL,0xa0/*P2*/,5);

void usb_req_class()
{
    switch (Setup.bRequest)
    {
    case GET_REPORT:
        usb_get_report();
        break;
    case SET_REPORT:
        usb_set_report();
        break;
    case GET_IDLE:
        usb_get_idle();
        break;
    case SET_IDLE:
        usb_set_idle();
        break;
    case GET_PROTOCOL:
        usb_get_protocol();
        break;
    case SET_PROTOCOL:
        usb_set_protocol();
        break;
    default:
        usb_setup_stall();
        return;
    }
}

void usb_get_report()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (IN_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    Ep0State.pData = (BYTE*)UsbBuffer;
    Ep0State.wSize = Setup.wLength;

    usb_setup_in();
}

void usb_set_report()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (OUT_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    Ep0State.pData = (BYTE*)UsbBuffer;
    Ep0State.wSize = Setup.wLength;

    usb_setup_out();
}

void usb_get_idle()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (IN_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    Ep0State.pData = (BYTE*)&bHidIdle;
    Ep0State.wSize = 1;

    usb_setup_in();
}

void usb_set_idle()
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (OUT_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {
        usb_setup_stall();
        return;
    }

    bHidIdle = Setup.wValueH;

    usb_setup_status();
}

void usb_get_protocol()
{
    usb_setup_stall();
}

void usb_set_protocol()
{
    usb_setup_stall();
}

void usb_class_out()
{
    BYTE led;
    
    if (usb_bulk_intr_out(UsbBuffer, 1) == 1)
    {
        led = UsbBuffer[0];
        LED_NUM = !(led & 0x01);
        LED_CAPS = !(led & 0x02);
        LED_SCROLL = !(led & 0x04);
    }
}

void usb_class_in()
{
    BYTE key[8];
    BYTE button[3];
    BYTE i;
    
    if (DeviceState != DEVSTATE_CONFIGURED)
        return;

    if(KEY2)
    {
        if (!Usb1InBusy && fKeyOK)
        {
            fKeyOK = 0;

            key[0] = 0;
            key[1] = 0;
            key[2] = 0;
            key[3] = 0;
            key[4] = 0;
            key[5] = 0;
            key[6] = 0;
            key[7] = 0;

            switch (bKeyCode)
            {
                case 0x01:  key[2] = 0x1e; break;
//                case 0x02:  key[2] = 0x1f; break;
//                case 0x03:  key[2] = 0x20; break;
            }
            
            IE2 &= ~EUSB;
            Usb1InBusy = 1;
            usb_write_reg(INDEX, 1);
            for (i=0; i<8; i++)
            {
                usb_write_reg(FIFO1, key[i]);
            }
            usb_write_reg(INCSR1, INIPRDY);
            IE2 |= EUSB;
        }
    }
    else
    {
        if (!Usb2InBusy && fKeyOK)
        {
            fKeyOK = 0;

            button[0] = 0;
            button[1] = 0;
            button[2] = 0;

            switch (bKeyCode)
            {
                case 0x01:  button[0] = 0x01; break;
//                case 0x02:  button[0] = 0x02; break;
//                case 0x03:  button[0] = 0x04; break;
            }
            
            IE2 &= ~EUSB;
            Usb2InBusy = 1;
            usb_write_reg(INDEX, 2);
            for (i=0; i<3; i++)
            {
                usb_write_reg(FIFO2, button[i]);
            }
            usb_write_reg(INCSR1, INIPRDY);
            IE2 |= EUSB;
        }
    }
}

void scan_key()
{
	if(!KEY1)
	{
		if(!Key1_Flag)
		{
			Key1_cnt++;
			if(Key1_cnt >= 50)  //50ms
			{
				Key1_Flag = 1;  //ð״ֹ̬ظ
				bKeyCode |= 1;
                fKeyOK = 1;
			}
		}
	}
	else
	{
		Key1_cnt = 0;
        if(Key1_Flag)
        {
            bKeyCode &= ~1;
            fKeyOK = 1;
            Key1_Flag = 0;
        }
	}
}
